&& Dependency
*================================================================================
&& Gregory Adam - 2006
*================================================================================

#include	..\Include\Tools_Base.h


#define SESSIONPRIVATE_BLANK_CLASS	DATASESSION_CLASS_BASE

#define DEPENDENCY_CLASS		[DependencyClass]
*-------------------------------------------------------------------------------
#if FALSE
	Forest of simple acyclic directed graphs
#endif
*-------------------------------------------------------------------------------
function Dependency_Object(obj)
	
	return Object_create(@m.obj, DEPENDENCY_CLASS)
	
endfunc
*---------------------------------------------------------------------------
*-------------------------------------------------------------------------------
#if FALSE
&& methods
	
	- Clear()
	- Edge(Successor, Predecessor)		&& adds and Edge, Successor depends on Predecessor
										&& eg, Edge('Pay', 'Work') Pay depends on Work
										&& returns TRUE if successful
										
	- Edge(Successor)					&& include a node, no dependency
	- Edge(Successor, null)
	
	- Dependency(@QueueObject, @CycleInfoString)	&& returns TRUE or FALSE (cycles)
	
#endif
*-------------------------------------------------------------------------------
#define NODE_MAX_NAME_LENGTH	(96-1-1-12)
*--------------------------------------------------------------------------
define Class DEPENDENCY_CLASS as SESSIONPRIVATE_BLANK_CLASS

	NodeIdInteger	= null
*--------------------------------------------------------------------------
hidden function init()

	do case
	case !DoDefault()
		assert FALSE
		return FALSE
	
	case !m.this.Clear()
		assert FALSE
		return FALSE
		
	endcase
endfunc
*--------------------------------------------------------------------------
function Clear()

	with m.this
		
		use in (select('NodeCursor'))
		
		.NodeIdInteger	= null	&& Not defined yet
		return .RelationCursor_Create()
	endwith
endfunc
*--------------------------------------------------------------------------
*--------------------------------------------------------------------------
hidden function NodeCursor_Create()

	with m.this
	
		do case
		case .NodeIdInteger
		
			create cursor NodeCursor ;
			(	Visited		L		default FALSE, ;	&& Circular Info
				Id			I		check (Id > 0) error 'Id >0' default 0, ;
				InDegree	I		check (InDegree >= 0) error 'InDegree >= 0' default 0 ;
			)
			
			index on Id tag Id candidate
		
		otherwise
			create cursor NodeCursor ;
			(	Visited		L		default FALSE, ;	&& Circular Info
				Id			I		check (Id > 0) error 'Id >0' default 0, ;
				InDegree	I		check (InDegree >= 0) error 'InDegree >= 0' default 0, ;
				NodeId		c(NODE_MAX_NAME_LENGTH), ;
				NodeId_len	I		default 0 ;
			)
			
			index on Id tag Id candidate
			index on NodeId tag NodeId candidate

			&& order = Name during building phase
		
		endcase
		
	endwith
	
endfunc
*--------------------------------------------------------------------------
hidden function RelationCursor_Create()

	create cursor RelationCursor ;
	(	Predecessor	I	check (Predecessor>0), ;
		Successor	I	check (Successor>0) ;
	)
	
	
	index on bintoc(Predecessor) + bintoc(Successor) tag Id candidate

endfunc
*--------------------------------------------------------------------------
function Id_get(NodeId, Id)

	with m.this
		if( isnull(.NodeIdInteger) )
			store !inlist(vartype(m.NodeId), T_CHARACTER, T_MEMO) to .NodeIdInteger
			if( !.NodeCursor_Create() )
				assert FALSE
				return FALSE
			endif
		endif
		
		if( .NodeIdInteger)
	
			if( !seek(m.NodeId) )
				insert into NodeCursor ;
					(	Visited, ;
						Id, ;
						InDegree ;
					) values ;
					(	FALSE, ;
						m.NodeId, ;
						0 ;
					)
			endif
		else

			if( !seek(padr(m.NodeId, NODE_MAX_NAME_LENGTH)) )
				
				insert into NodeCursor ;
					(	Visited, ;
						Id, ;
						InDegree, ;
						NodeId, ;
						NodeId_len ;
					) values ;
					(	FALSE, ;
						reccount()+1, ;
						0, ;
						m.NodeId, ;
						len(m.NodeId) ;
					)
			endif
		endif
	
	endwith
	Id = Id	&& !!!
endfunc
*--------------------------------------------------------------------------
*--------------------------------------------------------------------------
*--------------------------------------------------------------------------
function Edge(Successor_Name, Predecessor_Name)

	with m.this
		
		local Successor_Id, Predecessor_Id
		
		do case
		case (pcount() < 2) or isnull(m.Predecessor_Name)
			return .Id_get(m.Successor_Name, @m.Successor_Id)
		
		&& the Id_get() order is important, 
		&& we want to be on the Successor node AFTER the seek/insert
		case !.Id_get(m.Predecessor_Name, @m.Predecessor_Id)
			assert FALSE
			return FALSE
	
		case !.Id_get(m.Successor_Name, @m.Successor_Id)
			assert FALSE
			return FALSE
		
		case m.Successor_Id == m.Predecessor_Id
			assert FALSE message 'Cyclic'
			return FALSE
			
		case indexseek(bintoc(m.Predecessor_Id) + bintoc(m.Successor_Id), FALSE, 'RelationCursor', 'Id')
			return TRUE
		
		otherwise
			repl InDegree with InDegree + 1	&& in NodeCursor
			
			insert into RelationCursor ;
				(	Predecessor, Successor ) ;
				values ;
				(	m.Predecessor_Id, m.Successor_Id )
		
		endcase
	endwith
endfunc
*--------------------------------------------------------------------------
function Dependency(OutputQueue, CircularInfo)

	with m.this
		
		local Cycles
		
		do case
		case !QueueBits_Object_Global(@m.OutputQueue)
			assert FALSE
			return FALSE
		
		case !.TopologicalSort(m.OutputQueue, @m.Cycles)
			assert FALSE
			return FALSE
		
		case !m.Cycles
			return TRUE
		
		case !.Circular(@m.CircularInfo)
			assert FALSE
			return FALSE
		
		otherwise
			return FALSE
		
		endcase
	endwith
endfunc
*--------------------------------------------------------------------------
#define DEPENDENCY_NODE_NAME	iif(m.this.NodeIdInteger, NodeCursor.Id, padr(NodeCursor.NodeId, NodeCursor.NodeId_len))

hidden function TopologicalSort(OutputQueue, Cycles)

	local Success
	Success = TRUE
	
	local i, Queue, Id
	
	select NodeCursor 
	index on InDegree tag InDegree
	
	do case
	case !m.Success
	
	case !QueueBits_Object(@m.Queue)
		assert FALSE
		return FALSE
	
	otherwise
		with m.Queue
			&& put each node with InDegree 0 in the queue
			set order to InDegree
			go top
			
			scan rest while m.Success and (InDegree = 0)
				if( !.EnQueue(id) )
					assert FALSE
					Success = FALSE
				endif
			endscan
		
			&& process the queue until empty
			set order to Id in NodeCursor
		
			select RelationCursor
	
			for i = 0 to 1 step 0
				
				do case
				case !m.Success or !.DeQueue(@m.Id)
					exit
					
				case !seek(m.Id, 'NodeCursor')
					assert FALSE
					return FALSE
					
				case !m.OutputQueue.EnQueue(DEPENDENCY_NODE_NAME)
					assert FALSE
					return FALSE
				
				case !seek(bintoc(m.Id)) and FALSE
				
				otherwise
					&& Decrease Indegree of all Successors, if 0 Queue it
					
					scan rest while (Predecessor == m.Id)
						
						do case
						case !seek(RelationCursor.Successor, 'NodeCursor')
							assert FALSE
							return FALSE
						
						case (NodeCursor.InDegree == 1) and !.EnQueue(NodeCursor.Id)
							assert FALSE
							return FALSE
						
						otherwise
							repl InDegree with InDegree - 1 in NodeCursor
						
						endcase
					endscan
				
				endcase
			endfor

		endwith

	endcase
	
	Cycles = (m.OutputQueue.Count <> reccount('NodeCursor'))
	
	return m.Success
	
endfunc
*--------------------------------------------------------------------------
hidden function Circular(CycleInfoString)

	&& (1) Delete all Nodes that have been processed
	select NodeCursor
	set order to Id in NodeCursor && just in case
	delete all for (InDegree = 0)
	repl InDegree with 0 all
	
	&& (2) for each node that has not been processed
	&&		place predecessor in InDegree of Successor
	
	local NodeId, r
	scan all
		store Id to NodeId	
		store recno() to r
		
		select RelationCursor
		=seek(bintoc(m.NodeId))
		scan rest while (Predecessor = m.NodeId)
		
			do case
			case !seek( Successor, 'NodeCursor')
				assert FALSE
				return FALSE
			
			case empty(NodeCursor.InDegree)
				repl InDegree with m.NodeId in NodeCursor
			
			endcase
		endscan
		select NodeCursor
		go (m.r)
		
	endscan
	
	&& (3) position on first Id that was not output
	locate for InDegree <> 0
	if( !Found() ) 
		assert FALSE
		return FALSE
	endif

	&& (4)  mark Predecessors with TRUE Visited fields
	store '' to CycleInfoString
	
	with m.this
		local NextId
		
		do while !Visited 
			repl Visited with TRUE
			NextId = InDegree
			
			store transf(DEPENDENCY_NODE_NAME) + ',' + m.CycleInfoString ;
					to CycleInfoString
					
			if( !seek(m.NextId) )
				assert FALSE
				return FALSE
			endif
		enddo
	endwith
	store left(m.CycleInfoString,len(m.CycleInfoString) - 1) to CycleInfoString
	
endfunc
*--------------------------------------------------------------------------
enddefine

*===============================================================================
*===============================================================================
*===============================================================================