&& Tools_Classes_base
&& (c) Gregory Adam 2008
*-------------------------------------------------------------------------------
#include	..\Include\Tools_Base.h
*-------------------------------------------------------------------------------
function Collection_Object(obj, GlobalDataSession)

	return Object_Create(@m.obj, COLLECTION_CLASS_BASE)
			
	
endfunc
*-------------------------------------------------------------------------------
function Session_Object(obj, GlobalDataSession)

	return Object_Create(@m.obj, DATASESSION_CLASS_BASE )
			
	
endfunc
*-------------------------------------------------------------------------------

*================================================================================
*================================================================================
*================================================================================
define Class DATASESSION_CLASS_BASE 	as	Session

*--------------------------------------------------------------------------
protected function init()

	do case
	case !DoDefault()
		assert FALSE
		return FALSE
	
	case !Tools_DataSession_Set()
		assert FALSE
		return FALSE
	
	endcase
endfunc
*--------------------------------------------------------------------------
protected function Destroy()
	
	return DoDefault()
endfunc
*--------------------------------------------------------------------------
function Release()
	
	release m.this
endfunc
*--------------------------------------------------------------------------

enddefine
*================================================================================
*================================================================================
*================================================================================


*================================================================================
*================================================================================
*================================================================================
#if FALSE
	- properties
		- Keyed		returns TRUE if the items have a key
		
	- methods
		- Clear()	&& clears the collection
		- Empty()	&& return TRUE if the collection is empty
		
		- Add(item [, key])	
			&& overrides base class
			&&	returns TRUE if Successful add
			&&	returns FALSE if any error
		
		- Clone(@m.objOut, DeepCopy)
			&& clones a collection
			&& if DeepCopy = TRUE
			&&	all objects that have a Clone method will be cloned
			
		- Reverse()	&& reverses the items

#endif
define class COLLECTION_CLASS_BASE as Collection

	DataSessionId		= 0
	
	&& access method
	Keyed		= FALSE
*-------------------------------------------------------------------------------
protected function init()
	
	local Success
	Success = TRUE
	
	do case
	case !m.Success
	
	case !DoDefault()
		assert FALSE
		Success = FALSE
	
	case !AddProperty(m.this, 'DataSessionId', set('dataSession'))
		assert FALSE
		Success = FALSE
		
	endcase
	
	return m.Success
	
endfunc
*-------------------------------------------------------------------------------
protected function Destroy()
	
	
	return DoDefault()
endfunc
*-------------------------------------------------------------------------------
function Clear()

	local i
	
	with m.this
		for i = .Count to 1 step -1
			=.Remove(m.i)
		endfor
	
	endwith
	
endfunc
*-------------------------------------------------------------------------------
function Empty()

	return Empty(m.this.Count)

endfunc
*-------------------------------------------------------------------------------
function add(sValue, sKey)
	
	NODEFAULT
	
	local Success
	Success = TRUE
	
	do case
	case pcount() = 1
		
		try
			if( !DoDefault(m.sValue) )
				assert FALSE
				Success = FALSE
			endif
		catch
			assert FALSE
			Success = FALSE
		
		endtry
		
	otherwise
		try
			if( !DoDefault(m.sValue, m.sKey) )
				assert FALSE
				Success = FALSE
			endif
		catch
			assert FALSE
			Success = FALSE
		
		endtry
			
	endcase
	
	return m.Success
	
endfunc
*-------------------------------------------------------------------------------
function Keyed_Access()

	return !( empty(m.this.Count) or empty(m.this.getKey(1)) )
endfunc
*-------------------------------------------------------------------------------
#if FALSE
	DeepCopy = try to clone Objects if they have a Clone() method
	
#endif
function Clone(ObjOut, DeepCopy)

	local Success
	Success = TRUE
	
	local i, obj
	
	with m.this
		do case
		case !m.Success
		
		case !Object_Create(@m.objOut, m.this.Class)
			assert FALSE
			Success = FALSE
		
		case .Empty()
		
		case !m.DeepCopy
			
			do case
			case !m.this.Keyed
				for i = 1 to .Count
					if( !m.ObjOut.Add(.Item[m.i]) )
						assert FALSE
						Success = FALSE
						exit
					endif
				endfor
			
			&& Keyed collection
			otherwise
				for i = 1 to .Count
					if( !m.ObjOut.Add(.Item[m.i], .GetKey[m.i]) )
						assert FALSE
						Success = FALSE
						exit
					endif
				endfor
			endcase
			
		&& DeepCopy
		otherwise
	
			do case
			case !m.this.Keyed
				local obj
				
				for i = 1 to .Count
					obj = .Item[m.i]
					
					do case
					case !IsObject(m.Obj) or !PemStatus(m.obj, 'Clone', 5)
						if( !m.ObjOut.Add(m.Obj) )
							assert FALSE
							Success = FALSE
							exit
						endif
					
					case !m.obj.Clone(@m.obj, TRUE)
						assert FALSE
						Success = FALSE
						exit
					
					case !m.ObjOut.Add(m.Obj)
						assert FALSE
						Success = FALSE
						exit
					
					endcase
				endfor
			
			&& Keyed collection
			otherwise
				local obj
				
				for i = 1 to .Count
					obj = .Item[m.i]
					
					do case
					case !IsObject(m.Obj) or !PemStatus(m.obj, 'Clone', 5)
						if( !m.ObjOut.Add(m.Obj, .GetKey[m.i]) )
							assert FALSE
							Success = FALSE
							exit
						endif
					
					case !m.obj.Clone(@m.obj, TRUE)
						assert FALSE
						Success = FALSE
						exit
					
					case !m.ObjOut.Add(m.Obj, .GetKey[m.i])
						assert FALSE
						Success = FALSE
						exit
					
					endcase
				endfor
			endcase
		endcase
	
	endwith
	
	return m.Success
	
endfunc
*-------------------------------------------------------------------------------
function Reverse()

	local Success
	Success = TRUE
	
	local i, obj
	
	
	do case
	case !m.Success
	
	case m.this.Count <= 1
	
	case !m.this.Clone(@m.obj)
		assert FALSE
		Success = FALSE
	
	case !m.this.Clear()
		assert FALSE
		Success = FALSE
		
	case !m.obj.Keyed
		
		with m.this
			for i = m.obj.Count to 1 step -1
				if( !.Add(m.obj.item[m.i]) )
					assert FALSE
					Success = FALSE
					exit
				endif
			endfor
		endwith
		
	&& keyed
	otherwise
		with m.obj
		
			for i = .Count to 1 step -1
				
				if( !m.this.Add(.Item[m.i], .GetKey(m.i)) )
					assert FALSE
					Success = FALSE
					exit
				endif
		
			endfor
	
		endwith
	endcase
	
	
	return m.Success
	
endfunc
*-------------------------------------------------------------------------------

enddefine
*================================================================================
*================================================================================
*================================================================================